Attribute VB_Name = "FESDefs"
Option Explicit

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" _
    (ByVal lpClassName As Long, ByVal lpWindowName As String) As Long
Public Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" _
    (ByVal hWndParent As Long, ByVal hWndChildAfter As Long, _
    ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" _
    (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

Public Declare Function fopen Lib "release\cfuncs.dll" Alias "_do_fopen@8" _
    (ByVal Path As String, ByVal Mode As String) As Long
Public Declare Function fclose Lib "release\cfuncs.dll" Alias "_do_fclose@4" _
    (ByVal FPtr As Long) As Long
Public Declare Function ReadLine Lib "release\cfuncs.dll" Alias "_ReadLine@12" _
    (ByVal Line As String, ByVal MaxLen As Long, ByVal FPtr As Long) As Long

Public Declare Sub SetConvertAllBackSlashesToDashesMode Lib _
    "release\cfuncs.dll" Alias "_SetConvertAllBackSlashesToDashesMode@4" _
    (ByVal Flag As Long)
Public Declare Sub EnableDisableLineTerminationWarnings Lib _
    "release\cfuncs.dll" Alias "_EnableDisableLineTerminationWarnings@4" _
    (ByVal Flag As Long)
Public Declare Function ReadAndProcessCSVLine Lib "release\cfuncs.dll" _
    Alias "_ReadAndProcessCSVLine@12" (ByVal Line As String, _
    ByVal MaxLen As Long, ByVal FPtr As Long) As Long
Public Declare Function CountLinesInFileAndGetLongestLine Lib "release\cfuncs.dll" _
    Alias "_CountLinesInFileAndGetLongestLine@12" (ByVal Path As String, _
    ByRef FirstLineLength As Long, ByRef LongestRemainingLine As Long) As Long
Public Declare Sub CountLongestLine Lib "release\cfuncs.dll" _
    Alias "_CountLongestLine@12" (ByVal Path As String, _
    ByRef FirstLineLength As Long, ByRef LongestRemainingLine As Long)
Public Declare Function WriteStringToFile Lib "release\cfuncs.dll" Alias _
    "_WriteStringToFile@8" (ByVal s As String, ByVal FPtr As Long) As Long

Public Declare Sub FixCountsRecord Lib "release\cfuncs.dll" Alias _
    "_FixCountsRecord@4" (ByVal s As String)
Public Declare Sub FixManagedRecord Lib "release\cfuncs.dll" Alias _
    "_FixManagedRecord@4" (ByVal s As String)
Public Declare Sub FixProductionRecord Lib "release\cfuncs.dll" Alias _
    "_FixProductionRecord@4" (ByVal s As String)
Public Declare Function FixIndexRecord Lib "release\cfuncs.dll" Alias _
    "_FixIndexRecord@8" (ByVal s As String, ByVal Flag As Long) As Long
Public Declare Sub FixIndexOCVRecord Lib "release\cfuncs.dll" Alias _
    "_FixIndexOCVRecord@4" (ByVal s As String)
Public Declare Function CountColumns Lib "release\cfuncs.dll" _
    Alias "_CountColumns@4" (ByVal hptr As String) As Long

Public ReplyReceived As Boolean
Public DatabaseName As String
Public SQLUser As String
Public SQLPassword As String

Public Function ResolveQuotes(TextStg As String) As String
    Dim Pos As Integer, SourceStg As String

    ' Pair up all single quotes found in the given string.

    ResolveQuotes = ""
    SourceStg = TextStg
    Do
        Pos = InStr(SourceStg, "'")
        If Pos <= 0 Then Exit Do

        ResolveQuotes = ResolveQuotes & Left(SourceStg, Pos) & "'"
        SourceStg = Mid(SourceStg, Pos + 1)
    Loop
    ResolveQuotes = ResolveQuotes & SourceStg
End Function

Public Sub NiceSleep(ms As Long)
    Dim ii As Long

    ' Sleep the number of ms, 10ms as at at time, yielding to the event machine.with doevents

    For ii = 0 To ms Step 10
        Sleep 10
        DoEvents
        DoEvents
        DoEvents
    Next ii
End Sub

Public Function FileExists(FileName As String) As Boolean
    FileExists = True
    On Error GoTo LenErrorCode
    FileLen FileName
    Exit Function

LenErrorCode:
    FileExists = False
    Resume Next
End Function
