VERSION 5.00
Begin VB.Form GetFile
   BackColor       =   &H00FFE8F0&
   Caption         =   "Select a File"
   ClientHeight    =   4290
   ClientLeft      =   5910
   ClientTop       =   5265
   ClientWidth     =   5655
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4290
   ScaleWidth      =   5655
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame frBottom 
      BackColor       =   &H00FFE8F0&
      BorderStyle     =   0  'None
      Height          =   615
      Left            =   0
      TabIndex        =   8
      Top             =   3600
      Width           =   5655
      Begin VB.DriveListBox Drive1 
         Appearance      =   0  'Flat
         Height          =   315
         Left            =   3120
         TabIndex        =   12
         Top             =   240
         Width           =   2415
      End
      Begin VB.ComboBox cbPatterns 
         Appearance      =   0  'Flat
         Height          =   315
         Left            =   120
         Style           =   2  'Dropdown List
         TabIndex        =   11
         Top             =   240
         Width           =   2895
      End
      Begin VB.TextBox LabelDrives 
         Appearance      =   0  'Flat
         BackColor       =   &H00FFE8F0&
         BorderStyle     =   0  'None
         Height          =   230
         Left            =   3120
         TabIndex        =   10
         Text            =   "Drives:"
         Top             =   0
         Width           =   495
      End
      Begin VB.TextBox LabelList 
         Appearance      =   0  'Flat
         BackColor       =   &H00FFE8F0&
         BorderStyle     =   0  'None
         Height          =   230
         Left            =   120
         TabIndex        =   9
         Text            =   "List files of type:"
         Top             =   0
         Width           =   1215
      End
   End
   Begin VB.TextBox laFilePath 
      Appearance      =   0  'Flat
      BackColor       =   &H00FFE8F0&
      BorderStyle     =   0  'None
      Height          =   285
      Left            =   3120
      TabIndex        =   7
      Top             =   1320
      Width           =   2415
   End
   Begin VB.CommandButton bnCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4320
      TabIndex        =   6
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton bnOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   4320
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txFileName 
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   2895
   End
   Begin VB.DirListBox Dir1 
      Appearance      =   0  'Flat
      Height          =   1890
      Left            =   3120
      TabIndex        =   4
      Top             =   1635
      Width           =   2415
   End
   Begin VB.FileListBox File1 
      Appearance      =   0  'Flat
      Height          =   2760
      Left            =   120
      TabIndex        =   2
      Top             =   720
      Width           =   2895
   End
   Begin VB.Label Label3 
      BackColor       =   &H00FFE8F0&
      Caption         =   "&Folders:"
      Height          =   255
      Left            =   3120
      TabIndex        =   3
      Top             =   1080
      Width           =   615
   End
   Begin VB.Label Label1 
      BackColor       =   &H00FFE8F0&
      Caption         =   "File &name:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   855
   End
End
Attribute VB_Name = "GetFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' Copyright (c) 2003-2007 BIQ, LLC
'
' $Author: chris $
' $Date: 2007/10/20 00:33:17 $
' $Header: /home/cvs/CVSROOT/Source/vb/CableBoxFES/GetFile.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Id: GetFile.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Name:  $
' $Locker:  $
' $Log: GetFile.frm,v $
' Revision 1.3  2007/10/20 00:33:17  chris
' Release version
'
' Revision 1.2  2007/08/08 17:34:58  chris
' First true release.
'
' Revision 1.1  2007/07/27 15:43:38  chris
' This is the first "complete" version.
'
' $RCSfile $
' $Revision: 1.3 $
' $Source: /home/cvs/CVSROOT/Source/vb/CableBoxFES/GetFile.frm,v $
' $State: Exp $

Public FilePath As String               ' path only. always ends with \
Public FullFileName As String           ' file name and type
Public JustFileName As String           ' file name only

Public InitDone As Boolean              ' True iff init routine was called
Public FileMustExist As Boolean         ' set True by caller if desired
Public IgnoreFile As Boolean            ' ditto, to avoid parsing file name
Public GetOnlyDir As Boolean            ' get a directory, not a file
Public GotFile As Boolean               ' GetFile sets if OK was pressed

Private DefaultDir As String
Private DefaultFile As String
Private ExtList() As String             ' list of types in the combo box
Private ExtListSize As Integer

Public Sub Init(DefCaption As String, DefPath As String, DefFile As String, _
  DefPattern As String)
    Dim Pos As Integer, pos1 As Integer

    On Error Resume Next
    DefaultDir = CurDir
    If Len(DefCaption) <> 0 Then Me.Caption = DefCaption
    If Len(DefPath) <> 0 Then
        Pos = InStr(DefPath, ":")
        If Pos > 0 Then Drive1.Drive = Mid(DefPath, 1, Pos)
        Dir1.Path = DefPath
    End If

    ExtListSize = 0
    ReDim ExtList(0)
    cbPatterns.Clear
    If Len(DefPattern) <> 0 Then
        DefPattern = DefPattern & "|"
        Do
            Pos = InStr(DefPattern, "|")
            pos1 = InStr(Pos + 1, DefPattern, "|")
            If (Pos <= 1) Or (pos1 <= 1) Then Exit Do
            SaveExt Mid(DefPattern, 1, Pos - 1), _
                Mid(DefPattern, Pos + 1, pos1 - Pos - 1)

            DefPattern = Mid(DefPattern, pos1 + 1)
        Loop
    Else
        SaveExt "All files (*.*)", "*.*"
    End If
    If cbPatterns.ListCount > 0 Then cbPatterns.Text = cbPatterns.List(0)

    DefaultFile = DefFile
    InitDone = True
End Sub

Private Sub SaveExt(NewDesc As String, NewExt As String)
    cbPatterns.AddItem NewDesc

    ReDim Preserve ExtList(ExtListSize + 1)
    ExtList(ExtListSize) = NewExt
    ExtListSize = ExtListSize + 1
End Sub

Public Sub Setup()
    ' Perform setup that's done on each entry to this module.

    If cbPatterns.ListCount > 0 Then cbPatterns.Text = cbPatterns.List(0)
    File1.ListIndex = -1
    txFileName = IIf(GetOnlyDir, DefaultDir, DefaultFile)
    DefaultFile = ""
    txFileName.Locked = FileMustExist
    On Error Resume Next
    txFileName.SetFocus
End Sub

Private Sub bnCancel_Click()
    FileMustExist = False
    GetOnlyDir = False
    GotFile = False
    ChDir DefaultDir
    Me.Hide
End Sub

Private Sub bnOK_Click()
    txFileName = Trim(txFileName)
    If (Not IgnoreFile) And (Len(txFileName) = 0) Then Exit Sub

    GotFile = True
    If GetOnlyDir Then
        FilePath = txFileName
    Else
        FilePath = Dir1.Path
        If Mid(FilePath, Len(FilePath), 1) <> "\" Then FilePath = FilePath & "\"
        JustFileName = txFileName
        If Not FileMustExist Then _
            If (InStr(JustFileName, ".") <= 0) And (cbPatterns.ListIndex >= 0) And _
               (ExtList(cbPatterns.ListIndex) <> "*.*") Then _
                JustFileName = JustFileName & Mid(ExtList(cbPatterns.ListIndex), 2)
    
        FullFileName = FilePath & JustFileName
    End If
    FileMustExist = False
    GetOnlyDir = False
    ChDir DefaultDir
    Me.Hide
End Sub

Private Sub cbPatterns_Click()
    If cbPatterns.ListIndex >= 0 Then _
        File1.Pattern = ExtList(cbPatterns.ListIndex)
End Sub

Private Sub Drive1_Change()
    On Error Resume Next
    Dir1.Path = Drive1.Drive
    ChDrive Drive1.Drive
End Sub

Private Sub Dir1_Change()
    On Error Resume Next
    laFilePath = Dir1.Path
    File1.Path = Dir1.Path
    ChDir Dir1.Path
    If GetOnlyDir Then txFileName = Dir1.Path
End Sub

Private Sub Dir1_Click()
    If Not GetOnlyDir Then Exit Sub
    If Dir1.ListIndex > -1 Then txFileName = Dir1.List(Dir1.ListIndex)
End Sub

Private Sub File1_DblClick()
    If GetOnlyDir Then Exit Sub
    bnOK_Click
End Sub

Private Sub File1_Click()
    If GetOnlyDir Then Exit Sub
    If File1.ListIndex > -1 Then txFileName = File1.FileName
End Sub

Private Sub Form_Resize()
    Static OrgWidth As Integer

    If OrgWidth = 0 Then OrgWidth = Me.Width
    If Me.Width <> OrgWidth Then Me.Width = OrgWidth

    If Me.Height < 2000 Then Exit Sub
    frBottom.Top = Me.Height - 1065
    File1.Height = Me.Height - 1845
    Dir1.Height = Me.Height - 2775
End Sub
