VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.Form Reports 
   Caption         =   "Display and Output Reports"
   ClientHeight    =   10470
   ClientLeft      =   4395
   ClientTop       =   4200
   ClientWidth     =   8775
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   10470
   ScaleWidth      =   8775
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.ListView lvReport 
      Height          =   9735
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   8535
      _ExtentX        =   15055
      _ExtentY        =   17171
      Sorted          =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   16777215
      BorderStyle     =   1
      Appearance      =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Times New Roman"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   0
   End
   Begin VB.CommandButton bnOutput 
      Caption         =   "&Output to file"
      Enabled         =   0   'False
      Height          =   375
      Left            =   6000
      TabIndex        =   2
      Top             =   90
      Width           =   1455
   End
   Begin VB.ComboBox cbReport 
      Height          =   315
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   120
      Width           =   2775
   End
   Begin VB.CommandButton bnClose 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   375
      Left            =   7800
      TabIndex        =   3
      Top             =   90
      Width           =   855
   End
   Begin VB.CommandButton bnDisplay 
      Caption         =   "&Display"
      Height          =   375
      Left            =   4440
      TabIndex        =   1
      Top             =   90
      Width           =   1455
   End
   Begin RichTextLib.RichTextBox rtReport 
      Height          =   9735
      Left            =   120
      TabIndex        =   6
      Top             =   600
      Visible         =   0   'False
      Width           =   8535
      _ExtentX        =   15055
      _ExtentY        =   17171
      _Version        =   393217
      Appearance      =   0
      TextRTF         =   $"Reports.frx":0000
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Times New Roman"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin VB.Label Label1 
      Caption         =   "Type of Report"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   180
      Width           =   1335
   End
End
Attribute VB_Name = "Reports"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub DisplayResets()
    Dim DateEntered As Date
    Dim lvTemp As ListItem

    ' Display the Counters Reset report in the window.

    lvReport.ListItems.Clear
    lvReport.ColumnHeaders.Clear
    lvReport.ColumnHeaders.Add , , "Date of Reset", 1700
    lvReport.ColumnHeaders.Add , , "Operator", 1700
    lvReport.ColumnHeaders.Add , , "Detail", 5300
    lvReport.ColumnHeaders.Add , , "Reason", 2000
    lvReport.SortKey = 0
    lvReport.SortOrder = lvwAscending

    On Error Resume Next
    If Not SQLStartQueryWithResults( _
        "select OperatorID, DateEntered, Detail, Reason from FESExceptions " & _
        "where ExceptionType = 4 order by ExceptionID") Then Exit Sub

    Do While Not SQLAtEndOfSet
        Set lvTemp = lvReport.ListItems.Add
        DateEntered = SQLGetFieldAsString(1)
        lvTemp.Text = Format(DateEntered, "yyyy/mm/dd hh:nn")
        lvTemp.SubItems(1) = GetOperatorName(SQLGetFieldAsString(0))
        lvTemp.SubItems(2) = SQLGetFieldAsString(2)
        lvTemp.SubItems(3) = SQLGetFieldAsString(3)
        SQLGetNextRow
    Loop
End Sub

Private Sub DisplayExceptions()
    Dim ExceptionType As String
    Dim DateEntered As Date
    Dim lvTemp As ListItem

    ' Display the Exceptions report in the window.

    lvReport.ListItems.Clear
    lvReport.ColumnHeaders.Clear
    lvReport.ColumnHeaders.Add , , "Type", 1500
    lvReport.ColumnHeaders.Add , , "Operator", 1500
    lvReport.ColumnHeaders.Add , , "Exception Date", 1700
    lvReport.ColumnHeaders.Add , , "Detail", 4300
    lvReport.ColumnHeaders.Add , , "Reason", 1700
    lvReport.SortKey = 2
    lvReport.SortOrder = lvwAscending

    On Error Resume Next
    If Not SQLStartQueryWithResults( _
        "select ExceptionType, OperatorID, DateEntered, Detail, Reason " & _
        "from FESExceptions where ExceptionType <> 4 order by ExceptionID") _
        Then Exit Sub

    Do While Not SQLAtEndOfSet
        ExceptionType = SQLGetFieldAsString(0)
        DateEntered = SQLGetFieldAsString(2)

        Select Case ExceptionType
            Case "1"
                ExceptionType = "File date gap"
            Case "2"
                ExceptionType = "Batch replay"
            Case "3"
                ExceptionType = "No index file"
            Case "5"
                ExceptionType = "Replay all"
            Case "6"
                ExceptionType = "Archive data"
            Case "7"
                ExceptionType = "Restore archive"
        End Select

        Set lvTemp = lvReport.ListItems.Add
        lvTemp.Text = ExceptionType
        lvTemp.SubItems(1) = GetOperatorName(SQLGetFieldAsString(1))
        lvTemp.SubItems(2) = Format(DateEntered, "yyyy/mm/dd hh:nn")
        lvTemp.SubItems(3) = SQLGetFieldAsString(3)
        lvTemp.SubItems(4) = SQLGetFieldAsString(4)
        SQLGetNextRow
    Loop
End Sub

Private Sub DisplayFilesInput()
    Dim ii As Integer
    Dim DateEntered As Date
    Dim FileName As String
    Dim lvTemp As ListItem

    ' Display the Files Input report in the window.
    '@@ ask for date range?

    On Error Resume Next
    If Not SQLStartQueryWithResults( _
        "select FileName, DateEntered, Records, OperatorID, Truncated " & _
        "from FESInputFiles order by InputFileID") Then Exit Sub

    lvReport.ListItems.Clear
    lvReport.ColumnHeaders.Clear
    lvReport.ColumnHeaders.Add , , "File Name", 4000
    lvReport.ColumnHeaders.Add , , "Date Entered", 1700
    lvReport.ColumnHeaders.Add , , "Records", 1000
    lvReport.ColumnHeaders.Add , , "Operator", 1700
    lvReport.ColumnHeaders.Add , , "Archived", 1000
    lvReport.SortKey = 1
    lvReport.SortOrder = lvwAscending

    Do While Not SQLAtEndOfSet
        Set lvTemp = lvReport.ListItems.Add
        FileName = SQLGetFieldAsString(0)
        lvTemp.Text = FileName
        DateEntered = SQLGetFieldAsString(1)
        lvTemp.SubItems(1) = Format(DateEntered, "yyyy/mm/dd hh:nn")
        lvTemp.SubItems(2) = SQLGetFieldAsString(2)
        lvTemp.SubItems(3) = GetOperatorName(SQLGetFieldAsString(3))
        lvTemp.SubItems(4) = IIf(SQLGetFieldAsString(4) = "1", "Yes", "")

        ' See if this file has been re-read. If so, talk about it (them).

        If AltSQLStartQueryWithResults("select OperatorID, DateEntered, Detail " & _
            "from FESExceptions where Detail like '" & FileName & _
            "%' and ExceptionType = 2 order by DateEntered") Then

            Do While Not AltSQLAtEndOfSet
                Set lvTemp = lvReport.ListItems.Add
                lvTemp.Text = FileName & " (Reread)"
                DateEntered = AltSQLGetFieldAsString(1)
                lvTemp.SubItems(1) = Format(DateEntered, "yyyy/mm/dd hh:nn")
                lvTemp.SubItems(2) = Mid(AltSQLGetFieldAsString(2), Len(FileName) + 3)
                lvTemp.SubItems(3) = GetOperatorName(AltSQLGetFieldAsString(0))
                lvTemp.SubItems(4) = ""
                AltSQLGetNextRow
            Loop
        End If

        SQLGetNextRow
    Loop
End Sub

Private Sub CopyLVtoRTF()
    Dim ii As Integer, jj As Integer
    Dim ReportTitle As String, ReportLine As String
    Dim SubItemCount As Integer

    rtReport.Text = ""
    rtReport.SelText = ""
    rtReport.SelUnderline = False

    If cbReport.Text = "Counter Resets" Then
        ReportTitle = "Resets Report"
        ReportLine = "Date of Reset" & vbTab & "Operator" & vbTab & _
            "Detail" & vbTab & "Reason"
        SubItemCount = 3

        rtReport.SelTabCount = 4
        rtReport.SelTabs(0) = 1800
        rtReport.SelTabs(1) = 3500
        rtReport.SelTabs(2) = 5600
        rtReport.SelTabs(3) = 10200
    ElseIf cbReport.Text = "Exceptions" Then
        ReportTitle = "Exceptions Report"
        ReportLine = "Type" & vbTab & "Operator" & vbTab & _
            "Exception Date" & vbTab & "Detail" & vbTab & "Reason"
        SubItemCount = 4

        rtReport.SelTabCount = 5
        rtReport.SelTabs(0) = 1300
        rtReport.SelTabs(1) = 2600
        rtReport.SelTabs(2) = 4400
        rtReport.SelTabs(3) = 9500
        rtReport.SelTabs(4) = 10200
    Else            ' "Files Input"
        ReportTitle = "Daily Files Input"
        ReportLine = "File Name" & vbTab & "Date Entered" & vbTab & _
            "Records" & vbTab & "Operator" & vbTab & "Archived" & vbTab & vbCrLf
        SubItemCount = 4

        rtReport.SelTabCount = 5
        rtReport.SelTabs(0) = 4850
        rtReport.SelTabs(1) = 6700
        rtReport.SelTabs(2) = 7850
        rtReport.SelTabs(3) = 10350
        rtReport.SelTabs(4) = 12300
    End If

    rtReport.SelFontSize = 18
    rtReport.SelBold = True
    rtReport.SelColor = RGB(0, 0, 255)
    rtReport.SelAlignment = rtfCenter
    rtReport.SelText = ReportTitle & vbCrLf

    rtReport.SelColor = RGB(0, 0, 255)
    rtReport.SelText = "Created " & Format(Now, "mmmm d, yyyy") & vbCrLf & vbCrLf

    rtReport.SelAlignment = rtfLeft
    rtReport.SelUnderline = True
    rtReport.SelText = ReportLine & vbTab & vbCrLf
    rtReport.SelUnderline = False

    For ii = 1 To lvReport.ListItems.Count
        ReportLine = lvReport.ListItems(ii).Text
        For jj = 1 To SubItemCount
            ReportLine = ReportLine & vbTab & lvReport.ListItems(ii).SubItems(jj)
        Next jj

        rtReport.SelText = ReportLine & vbCrLf
    Next ii
    rtReport.SelStart = 0
End Sub

Private Function GetOperatorName(OperatorID As String) As String
    ' Get the operator's name, given his ID.
    ' Automatic runs use the special canned operator ID and name.

    If OperatorID = 10000 Then
        GetOperatorName = "Automatic"
        Exit Function
    End If

    GetOperatorName = Trim(AltSQLGetSingleDatum( _
        "select Name from FESOperators where OperatorID = " & OperatorID))

    If Len(GetOperatorName) = 0 Then GetOperatorName = "Unknown"
End Function

Private Sub bnDisplay_Click()
    ' Display the selected report in the window.

    If cbReport.ListIndex < 0 Then
        MsgBox "Please select a report to display."
        Exit Sub
    End If

    ' Dispatch on the report desired, to display it in the window.

    Select Case cbReport.Text
        Case "Counter Resets"
            DisplayResets
        Case "Exceptions"
            DisplayExceptions
        Case "Files Input"
            DisplayFilesInput
    End Select
    bnOutput.Enabled = True
End Sub

Private Sub bnOutput_Click()
    Dim rtfhdl As Long
    Dim SavePath As String

    ' Write the currently-displaying report to a file.
    ' Get the name of the output file.

    With GetFile
        .Init "Save Report File", BAS.OutputDir, "", _
            "Rich text files (*.rtf)|*.rtf|All files (*.*)|*.*"

        .FileMustExist = False
        .Setup
        .Show 1
        If Not .GotFile Then Exit Sub
        SavePath = .FullFileName
    End With

    CopyLVtoRTF                     ' copy the report into the Rich Text Box

    rtfhdl = fopen(SavePath, "wb")
    If rtfhdl = 0 Then
        MsgBox "Could not open """ & SavePath & """ for output.", _
            vbApplicationModal + vbExclamation, "Save file error"
        Exit Sub
    End If
    WriteStringToFile rtReport.TextRTF, rtfhdl
    fclose rtfhdl
    MsgBox "Done.", vbApplicationModal + vbInformation, "Report saved"
End Sub

Private Sub bnClose_Click()
    lvReport.ListItems.Clear
    lvReport.ColumnHeaders.Clear
    rtReport.Text = ""
    Me.Hide
End Sub

Private Sub lvReport_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    If lvReport.SortKey = ColumnHeader.Index - 1 Then
        lvReport.SortOrder = IIf(lvReport.SortOrder = lvwAscending, lvwDescending, lvwAscending)
    Else
        lvReport.SortKey = ColumnHeader.Index - 1
    End If
End Sub

Private Sub Form_Load()
    Me.Width = 11400
    cbReport.Clear
    cbReport.AddItem "Counter Resets"
    cbReport.AddItem "Exceptions"
    cbReport.AddItem "Files Input"
    cbReport.Text = "Files Input"
    lvReport.View = lvwReport
End Sub

Private Sub Form_Activate()
    bnDisplay_Click
End Sub

Private Sub Form_Resize()
    Static OrgWidth As Integer, OrgHeight As Integer

    If OrgWidth = 0 Then
        OrgWidth = 8700
        OrgHeight = Me.Height - 7000
        Exit Sub
    End If

    If Me.WindowState <> vbNormal Then Exit Sub

    If Me.Width < OrgWidth Then Me.Width = OrgWidth
    If Me.Height < OrgHeight Then Me.Height = OrgHeight
    rtReport.Width = Me.Width - 360
    rtReport.Height = Me.Height - rtReport.Top - 560
    lvReport.Width = Me.Width - 360
    lvReport.Height = Me.Height - lvReport.Top - 560
    bnClose.Left = Me.Width - bnClose.Width - 240
End Sub
