VERSION 5.00
Begin VB.Form GetArchive
   BackColor       =   &H00E0E0E0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Select Archive"
   ClientHeight    =   4455
   ClientLeft      =   4380
   ClientTop       =   4185
   ClientWidth     =   3300
   ControlBox      =   0   'False
   BeginProperty Font
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4455
   ScaleWidth      =   3300
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox liArchive
      BackColor       =   &H00FFFFFF&
      ForeColor       =   &H00000000&
      Height          =   3375
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   3
      Top             =   480
      Width           =   3015
   End
   Begin VB.CommandButton bnOK
      Caption         =   "O&K"
      Default         =   -1  'True
      Height          =   375
      Left            =   2280
      TabIndex        =   0
      Top             =   3960
      Width           =   855
   End
   Begin VB.CommandButton bnCancel
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Top             =   3960
      Width           =   855
   End
   Begin VB.Label laHeader
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0E0&
      Caption         =   "Select the archive to restore"
      ForeColor       =   &H00000000&
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   3015
   End
End
Attribute VB_Name = "GetArchive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public ArchiveOK As Boolean
Public ArchiveSelected As String

Public Sub Setup(DirName As String)
    Dim FileName As String

    liArchive.Clear
    FileName = Dir(DirName & "ArchiveData*.z", vbNormal)
    Do While Len(FileName) > 0
        liArchive.AddItem FileName
        FileName = Dir
    Loop

    If liArchive.ListCount > 0 Then
        liArchive.Selected(liArchive.ListCount - 1) = True
        ArchiveOK = True
    Else
        MsgBox "There are no archives to restore."
        ArchiveOK = False
    End If
End Sub

Private Sub bnCancel_Click()
    ArchiveOK = False
    Me.Hide
End Sub

Private Sub bnOK_Click()
    ' One and only one archive must be selected.

    If liArchive.SelCount <> 1 Then
        If liArchive.SelCount > 0 Then
            MsgBox "Please select an archive."
            Exit Sub
        Else
            MsgBox "Please select only one archive."
            Exit Sub
        End If
    End If

    ArchiveSelected = liArchive.List(liArchive.ListIndex)
    ArchiveOK = True
    Me.Hide
End Sub
