VERSION 5.00
Begin VB.Form Reason
   BackColor       =   &H00E0E0FF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Please explain"
   ClientHeight    =   1935
   ClientLeft      =   4380
   ClientTop       =   4185
   ClientWidth     =   5640
   ControlBox      =   0   'False
   BeginProperty Font
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1935
   ScaleWidth      =   5640
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txReason
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   5415
   End
   Begin VB.CommandButton bnOK
      Caption         =   "O&K"
      Default         =   -1  'True
      Height          =   375
      Left            =   4680
      TabIndex        =   2
      Top             =   1440
      Width           =   855
   End
   Begin VB.CommandButton bnCancel
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3720
      TabIndex        =   3
      Top             =   1440
      Width           =   855
   End
   Begin VB.Label Label1
      BackColor       =   &H00E0E0FF&
      Caption         =   "Reason:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   660
      Width           =   735
   End
   Begin VB.Label laHeader
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0FF&
      Caption         =   "Header"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   120
      Width           =   5415
   End
   Begin VB.Label laDetail
      Alignment       =   2  'Center
      BackColor       =   &H00E0E0FF&
      Caption         =   "Detail"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   360
      Width           =   5415
   End
End
Attribute VB_Name = "Reason"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' Copyright (c) 2003-2007 BIQ, LLC
'
' $Author: chris $
' $Date: 2007/10/20 00:33:17 $
' $Header: /home/cvs/CVSROOT/Source/vb/CableBoxFES/Reason.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Id: Reason.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Name:  $
' $Locker:  $
' $Log: Reason.frm,v $
' Revision 1.3  2007/10/20 00:33:17  chris
' Release version
'
' Revision 1.2  2007/08/08 17:34:58  chris
' First true release.
'
' Revision 1.1  2007/07/27 15:43:38  chris
' This is the first "complete" version.
'
' $RCSfile $
' $Revision: 1.3 $
' $Source: /home/cvs/CVSROOT/Source/vb/CableBoxFES/Reason.frm,v $
' $State: Exp $

Public ReasonOK As Boolean
Public ExceptionCommand As String
Private ExceptionType As Integer

Public Sub Setup(ExceptionTyp As Integer, Detail As String)
    ExceptionType = ExceptionTyp
    txReason = ""
    laDetail = Detail

    Select Case ExceptionType
        Case 1
            laHeader = "Please explain why there are no files for these dates:"
        Case 2
            laHeader = "Please explain why you want to replay this file:"
        Case 3
            laHeader = "Please explain why you are not producing an Index file."
        Case 5
            laHeader = "Please explain why you want to replay the entire database:"
        Case 6
            laHeader = "Please explain why you want to archive the current database:"
        Case 7
            laHeader = "Please explain why you want to restore the archive:"
    End Select
End Sub

Private Sub bnCancel_Click()
    ReasonOK = False
    Me.Hide
End Sub

Private Sub bnOK_Click()
    ' Require the operator to enter some kind of reason.

    txReason = Trim(txReason)
    If Len(txReason) = 0 Then
        MsgBox "Please enter a reason."
        Exit Sub
    End If

    If Len(txReason) > 254 Then
        MsgBox "Your reason is too long." & vbCrLf & "Please be less verbose."
        Exit Sub
    End If

    ' Save the Exceptions entry. Also, keep it around in a global variable.

    ExceptionCommand = "insert into FESExceptions values(" & BAS.ExceptionID & _
        ", " & ExceptionType & ", " & Password.OperatorID & ", '" & _
        Format(Now, "yyyymmdd hh:mm") & "', '" & laDetail & "', '" & _
        ResolveQuotes(txReason) & "')"

    SQLJustDoIt ExceptionCommand

    BAS.ExceptionID = BAS.ExceptionID + 1
    ReasonOK = True
    Me.Hide
End Sub
