VERSION 5.00
Begin VB.Form Reset
   BackColor       =   &H00E0E0FF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Reset a Cable Box's Counts"
   ClientHeight    =   1710
   ClientLeft      =   4380
   ClientTop       =   4185
   ClientWidth     =   5640
   ControlBox      =   0   'False
   BeginProperty Font
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1710
   ScaleWidth      =   5640
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txSerialNo
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   2280
      TabIndex        =   1
      Top             =   120
      Width           =   1695
   End
   Begin VB.TextBox txResetReason
      Appearance      =   0  'Flat
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   5415
   End
   Begin VB.CommandButton bnOK
      Caption         =   "O&K"
      Default         =   -1  'True
      Height          =   375
      Left            =   4680
      TabIndex        =   4
      Top             =   1200
      Width           =   855
   End
   Begin VB.CommandButton bnCancel
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3720
      TabIndex        =   5
      Top             =   1200
      Width           =   855
   End
   Begin VB.Label Label1
      BackColor       =   &H00E0E0FF&
      Caption         =   "Cable box &serial number"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   150
      Width           =   2055
   End
   Begin VB.Label Label2
      BackColor       =   &H00E0E0FF&
      Caption         =   "&Reason for reset"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   450
      Width           =   1455
   End
End
Attribute VB_Name = "Reset"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
' Copyright (c) 2003-2007 BIQ, LLC
'
' $Author: chris $
' $Date: 2007/10/20 00:33:17 $
' $Header: /home/cvs/CVSROOT/Source/vb/CableBoxFES/Reset.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Id: Reset.frm,v 1.3 2007/10/20 00:33:17 chris Exp $
' $Name:  $
' $Locker:  $
' $Log: Reset.frm,v $
' Revision 1.3  2007/10/20 00:33:17  chris
' Release version
'
' Revision 1.2  2007/08/08 17:34:58  chris
' First true release.
'
' Revision 1.1  2007/07/27 15:43:38  chris
' This is the first "complete" version.
'
' $RCSfile $
' $Revision: 1.3 $
' $Source: /home/cvs/CVSROOT/Source/vb/CableBoxFES/Reset.frm,v $
' $State: Exp $

Public ResetOK As Boolean
Private ResetType As String

Public Sub Setup(ResetTyp As String)
    ResetType = ResetTyp
    txSerialNo = ""
    txResetReason = ""
End Sub

Private Sub bnCancel_Click()
    ResetOK = False
    Me.Hide
End Sub

Private Sub bnOK_Click()
    txSerialNo = Trim(txSerialNo)
    If Len(txSerialNo) = 0 Then
        MsgBox "Please enter a cable box serial number."
        Exit Sub
    End If

#If 0 Then '@@
    ' Make sure that cable box exists.

    ReplyReceived = False
    BAS.MySend "$DoesCableBoxExist" & vbTab & txSerialNo
    Do
        NiceSleep 100
    Loop While Not ReplyReceived

    If BAS.EngineReplyValue <> "1" Then
        MsgBox "Cable box ID not found: " & txSerialNo
        Exit Sub
    End If
#End If

    ' Require the operator to enter some kind of reason.

    txResetReason = Trim(txResetReason)
    If Len(txResetReason) = 0 Then
        MsgBox "Please enter a reason."
        Exit Sub
    End If

    If Len(txResetReason) > 254 Then
        MsgBox "Your reason is too long." & vbCrLf & "Please be less verbose."
        Exit Sub
    End If

    ' Save the Exceptions entry.

    SQLJustDoIt "insert into FESExceptions values(" & BAS.ExceptionID & _
        ", 4, " & Password.OperatorID & ", '" & Format(Now, "yyyymmdd hh:mm") & _
        "', '" & txSerialNo & ": " & ResetType & "', '" & _
        ResolveQuotes(txResetReason) & "')"

    BAS.ExceptionID = BAS.ExceptionID + 1
    ResetOK = True
    Me.Hide
End Sub
